package com.akamai.osmf.samples.presenter
{
	import com.akamai.osmf.samples.view.BaseVideoView;
	
	import flash.events.Event;
	
	import org.openvideoplayer.components.ui.controlbar.view.GoLiveButton;
	import org.openvideoplayer.components.ui.shared.ControlType;
	import org.openvideoplayer.components.ui.shared.event.ControlEvent;
	import org.osmf.media.MediaFactory;
	import org.osmf.media.MediaPlayer;
	
	public class LiveControlBarPresenter extends BaseControlBarPresenter
	{
		private var goLiveButton:GoLiveButton;
		
		public function LiveControlBarPresenter(view:BaseVideoView, mediaPlayer:MediaPlayer, mediaFactory:MediaFactory, mediaResource:String)
		{
			super(view, mediaPlayer, mediaFactory, mediaResource);
		}
		
		override protected function setControlBarReferences():void
		{
			super.setControlBarReferences();
			
			goLiveButton = controlBar.getControl(ControlType.GO_LIVE_BUTTON) as GoLiveButton;
			goLiveButton.enabled = false;
		}
		
		override protected function setupControlBarListeners(add:Boolean=true):void
		{
			super.setupControlBarListeners(add);
			
			if (add)
			{
				controlBar.addEventListener(ControlEvent.GO_LIVE, onGoLive);
			}
			else
			{
				controlBar.removeEventListener(ControlEvent.GO_LIVE, onGoLive);
			}
		}

		override protected function onSeekComplete(event:ControlEvent):void
		{
			super.onSeekComplete(event);	
			
			if (scrubBar.getThumbPosition(mediaPlayer.duration) < mediaPlayer.duration)
			{
				goLiveButton.enabled = true;
			}
		}
		
		protected function onGoLive(event:Event):void
		{
			mediaPlayer.seek(mediaPlayer.duration);			
			goLiveButton.enabled = false;			
		}
	}
}
